Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4652)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4653)
@@ -8839,39 +8800,178 @@
 
 !--         calculate index of the grid with global indices (column(1),column(2))
-!--         in the array nzterr and plantt and id of the coresponding processor
-            CALL radiation_calc_global_offset( column(2), column(1), 0, 1, offs_glob=ig )
-
-            IF ( lastdist == 0._wp )  THEN
-               horz_entry = -HUGE(1._wp)
+!--         in the array nzterrt/b and plantt and id of the coresponding processor
+            CALL radiation_calc_global_offset( column(2), column(1), 0, 1, &
+                                               iproc=ip, offs_glob=ig )
+
+            IF ( ip_last < 0 )  THEN
+               horz_full_entry = -HUGE(1._wp)
+               horz_mixed_entry = -HUGE(1._wp)
             ELSE
-               horz_entry = (REAL(nzterr(ig), wp) + .5_wp - origin(1)) / lastdist
+               horz_full_entry = (REAL(nzterrb(ig), wp) + .5_wp - origin(1)) / lastdist
+               horz_mixed_entry = (REAL(nzterrt(ig), wp) + .5_wp - origin(1)) / lastdist
             ENDIF
-            horz_exit = (REAL(nzterr(ig), wp) + .5_wp - origin(1)) / nextdist
-
-            IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
-!
-!--            Identify vertical obstacles hit by rays in current column
-               DO WHILE ( lowest_free_ray > 0 )
-                  IF ( zdirs(lowest_free_ray) > horz_entry )  EXIT
+            horz_full_exit = (REAL(nzterrb(ig), wp) + .5_wp - origin(1)) / nextdist
+            horz_mixed_exit = (REAL(nzterrt(ig), wp) + .5_wp - origin(1)) / nextdist
+            is_mixed_col = ( nzterrt(ig) /= nzterrb(ig) )
+
+            IF ( rad_angular_discretization )  THEN
+!
+!--            Identify vertical full obstacles hit by rays in current column,
+!--            mixed rays need to be checked if they are already obstructed.
+               DO WHILE ( lowest_mixed_ray > lowest_free_ray )
+                  IF ( zdirs(lowest_mixed_ray) > horz_full_entry )  EXIT
 !
 !--               This may only happen after 1st column, so lastdir and lastcolumn are valid
-                  CALL request_itarget(lastdir,                                         &
-                        CEILING(-0.5_wp + origin(1) + zdirs(lowest_free_ray)*lastdist), &
-                        lastcolumn(1), lastcolumn(2),                                   &
-                        target_surfl(lowest_free_ray), target_procs(lowest_free_ray))
-                  lowest_free_ray = lowest_free_ray - 1
+                  IF ( target_surfl(lowest_mixed_ray) < 0 )  THEN
+                     CALL request_itarget(lastdir,                                                 &
+                           CEILING(-0.5_wp + origin(1) + zdirs(lowest_mixed_ray)*lastdist),        &
+                           lastcolumn(1), lastcolumn(2),                                           &
+                           target_surfl(lowest_mixed_ray))
+                  ENDIF
+                  lowest_mixed_ray = lowest_mixed_ray - 1
                ENDDO
 !
-!--            Identify horizontal obstacles hit by rays in current column
-               DO WHILE ( lowest_free_ray > 0 )
-                  IF ( zdirs(lowest_free_ray) > horz_exit )  EXIT
-                  CALL request_itarget(iup_u, nzterr(ig)+1, column(1), column(2), &
-                                       target_surfl(lowest_free_ray),           &
-                                       target_procs(lowest_free_ray))
-                  lowest_free_ray = lowest_free_ray - 1
+!--            Identify vertical full obstacles hit by rays in current column,
+!--            free rays need no individual checks.
+               DO WHILE ( lowest_mixed_ray > 0 )
+                  IF ( zdirs(lowest_mixed_ray) > horz_full_entry )  EXIT
+!
+!--               This may only happen after 1st column, so lastdir and lastcolumn are valid
+                  CALL request_itarget(lastdir,                                                    &
+                        CEILING(-0.5_wp + origin(1) + zdirs(lowest_mixed_ray)*lastdist),           &
+                        lastcolumn(1), lastcolumn(2),                                              &
+                        target_surfl(lowest_mixed_ray))
+                  lowest_mixed_ray = lowest_mixed_ray - 1
                ENDDO
-            ENDIF
-
-            horizon = MAX(horizon, horz_entry, horz_exit)
+               IF ( lowest_free_ray > lowest_mixed_ray )  lowest_free_ray = lowest_mixed_ray
+!
+!--            Identify targets for vertical mixed obstacles.
+!--            lowest_mixed_ray now points to bottom of vertical mixed obstacles.
+               IF ( is_mixed_col  .AND.  ip_last >= 0 )  THEN
+!
+!--               Load vertical surfaces belonging to previous column
+                  vert_col(:) = -999
+                  DO  isurf = surfg_col_start(ig_last), surfg_col_start(ig_last+1)-1
+                     IF ( surf(id, isurf) == lastdir )  THEN
+                        vert_col(surf(iz, isurf)) = isurf
+                     ENDIF
+                  ENDDO
+!
+!--               Previously mixed rays need to be checked whether they are obstructed
+                  DO  iray = lowest_mixed_ray, lowest_free_ray-1, -1
+                     IF ( zdirs(iray) > horz_mixed_entry )  EXIT
+                     IF ( target_surfl(iray) >= 0 )  CYCLE
+                     target_surfl(iray) = vert_col(CEILING(-0.5_wp +     &
+                                        origin(1) + zdirs(iray)*lastdist)) ! contains -999 if missing surface
+                  ENDDO
+!
+!--               Previously free rays cannot be obstructed yet
+                  DO  iray = lowest_free_ray, 1, -1
+                     IF ( zdirs(iray) > horz_mixed_entry )  THEN
+!
+!--                     Extend mixed rays by raising the lowest_free ray
+!--                     (remains unchanged if this is hit in 1st iteration)
+                        lowest_free_ray = iray
+                        EXIT
+                     ENDIF
+                     target_surfl(iray) = vert_col(CEILING(-0.5_wp +     &
+                                        origin(1) + zdirs(iray)*lastdist)) ! contains -999 if missing surface
+                  ENDDO
+               ENDIF ! end of mixed horizon
+!
+!--            Identify horizontal full obstacles hit by rays in current column,
+!--            mixed rays need to be checked if they are already obstructed.
+               DO WHILE ( lowest_mixed_ray > lowest_free_ray )
+                  IF ( zdirs(lowest_mixed_ray) > horz_full_exit )  EXIT
+                  IF ( target_surfl(lowest_mixed_ray) < 0 )  THEN
+                     CALL request_itarget(iup, nzterrb(ig)+1, column(1), column(2), &
+                                          target_surfl(lowest_mixed_ray))
+                  ENDIF
+                  lowest_mixed_ray = lowest_mixed_ray - 1
+               ENDDO
+!
+!--            Identify horizontal full obstacles hit by rays in current column,
+!--            free rays need no individual checks.
+               DO WHILE ( lowest_mixed_ray > 0 )
+                  IF ( zdirs(lowest_mixed_ray) > horz_full_exit )  EXIT
+                  CALL request_itarget(iup, nzterrb(ig)+1, column(1), column(2), &
+                                       target_surfl(lowest_mixed_ray))
+                  lowest_mixed_ray = lowest_mixed_ray - 1
+               ENDDO
+               IF ( lowest_free_ray > lowest_mixed_ray )  lowest_free_ray = lowest_mixed_ray
+!
+!--            Identify targets for horizontal mixed obstacles.
+!--            lowest_mixed_ray now points _above_ horizontal full obstacles.
+               IF ( is_mixed_col )  THEN
+!
+!--               Load horizontal surfaces corresponding to current column
+                  up_col(:) = -999
+                  down_col(:) = -999
+                  DO  isurf = surfg_col_start(ig), surfg_col_start(ig+1)-1
+                     SELECT CASE ( surf(id, isurf) )
+                     CASE ( iup )
+                        up_col(surf(iz, isurf)) = isurf
+                     CASE ( idown )
+                        down_col(surf(iz, isurf)) = isurf
+                     ENDSELECT
+                  ENDDO
+!
+!--               Previously mixed rays need to be checked whether they are obstructed
+                  DO  iray = lowest_mixed_ray, lowest_free_ray-1, -1
+                     IF ( zdirs(iray) > MAX(horz_mixed_entry, horz_mixed_exit) )  EXIT
+                     IF ( target_surfl(iray) >= 0 )  CYCLE
+                     IF ( zdirs(iray) <= 0._wp )  THEN
+!
+!--                     Downward pointed ray, cycle k down from entry to exit,
+!--                     search for upward oriented faces
+                        DO  k = FLOOR(0.5_wp + origin(1) + zdirs(iray)*lastdist), &
+                               CEILING(-0.5_wp + origin(1) + zdirs(iray)*nextdist)+1, -1
+                           target_surfl(iray) = up_col(k) ! contains -999 if missing surface
+                           IF ( target_surfl(iray) >= 0 )  EXIT
+                        ENDDO
+                     ELSE
+!
+!--                     Upward pointed ray, cycle k up from entry to exit,
+!--                     search for downward oriented faces
+                        DO  k = CEILING(-0.5_wp + origin(1) + zdirs(iray)*lastdist), &
+                               FLOOR(0.5_wp + origin(1) + zdirs(iray)*nextdist)-1
+                           target_surfl(iray) = down_col(k) ! contains -999 if missing surface
+                           IF ( target_surfl(iray) >= 0 )  EXIT
+                        ENDDO
+                     ENDIF
+                  ENDDO
+!
+!--               Previously free rays cannot be obstructed yet
+                  DO  iray = lowest_free_ray, 1, -1
+                     IF ( zdirs(iray) > MAX(horz_mixed_entry, horz_mixed_exit) )  THEN
+!
+!--                     Extend mixed rays by raising the lowest_free ray
+!--                     (remains unchanged if this is hit in 1st iteration)
+                        lowest_free_ray = iray
+                        EXIT
+                     ENDIF
+                     IF ( zdirs(iray) <= 0._wp )  THEN
+!
+!--                     Downward pointed ray, cycle k down from entry to exit,
+!--                     search upward oriented faces
+                        DO  k = FLOOR(0.5_wp + origin(1) + zdirs(iray)*lastdist), &
+                               CEILING(-0.5_wp + origin(1) + zdirs(iray)*nextdist)+1, -1
+                           target_surfl(iray) = up_col(k) ! contains -999 if missing surface
+                           IF ( target_surfl(iray) >= 0 )  EXIT
+                        ENDDO
+                     ELSE
+!
+!--                     Upward pointed ray, cycle k up from entry to exit,
+!--                     search downward oriented faces
+                        DO  k = CEILING(-0.5_wp + origin(1) + zdirs(iray)*lastdist), &
+                               FLOOR(0.5_wp + origin(1) + zdirs(iray)*nextdist)-1
+                           target_surfl(iray) = down_col(k) ! contains -999 if missing surface
+                           IF ( target_surfl(iray) >= 0 )  EXIT
+                        ENDDO
+                     ENDIF
+                  ENDDO
+               ENDIF ! end of mixed horizon
+            ENDIF ! rad_angular_discretization
+            full_horizon = MAX(full_horizon, horz_full_entry, horz_full_exit)
 
             IF ( plant_canopy )  THEN
@@ -8883,22 +8983,24 @@
          IF ( nextdist + eps >= distance )  EXIT
 
-         IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+         IF ( rad_angular_discretization )  THEN
 !
 !--         Save wall direction of coming building column (= this air column)
             IF ( seldim == 1 )  THEN
                IF ( dimdelta(seldim) == 1 )  THEN
-                  lastdir = isouth_u
+                  lastdir = isouth
                ELSE
-                  lastdir = inorth_u
+                  lastdir = inorth
                ENDIF
             ELSE
                IF ( dimdelta(seldim) == 1 )  THEN
-                  lastdir = iwest_u
+                  lastdir = iwest
                ELSE
-                  lastdir = ieast_u
+                  lastdir = ieast
                ENDIF
             ENDIF
             lastcolumn = column
          ENDIF
+         ip_last = ip
+         ig_last = ig
          lastdist = nextdist
          dimnext(seldim) = dimnext(seldim) + dimdelta(seldim)
@@ -8921,11 +9023,11 @@
 !--               For fixed view resolution, we need plant canopy even for rays
 !--               to opposing surfaces
-                  lowest_lad = nzterr(ig) + 1
+                  lowest_lad = nzterrb(ig) + 1
                ELSE
 !
-!--               We only need LAD for rays directed above horizon (to sky)
+!--               We only need LAD for rays directed above full horizon (to sky)
                   lowest_lad = CEILING( -0.5_wp + origin(1) +            &
-                                    MIN( horizon * rt2_track_dist(i-1),  & ! entry
-                                         horizon * rt2_track_dist(i)   ) ) ! exit
+                                    MIN( full_horizon * rt2_track_dist(i-1),  & ! entry
+                                         full_horizon * rt2_track_dist(i)   ) ) ! exit
                ENDIF
 !
@@ -8970,5 +9072,5 @@
       ENDIF ! plant_canopy
 
-      IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+      IF ( rad_angular_discretization )  THEN
 #if defined( __parallel )
 !--      wait for all gridsurf requests to complete
@@ -8979,18 +9081,13 @@
          ENDIF
 #endif
-!
-!--      recalculate local surf indices into global ones
-         DO i = 1, nrays
-            IF ( target_surfl(i) == -1 )  THEN
-               itarget(i) = -1
-            ELSE
-               itarget(i) = target_surfl(i) + surfstart(target_procs(i))
-            ENDIF
+         itarget(:) = target_surfl(:)
+         DEALLOCATE( target_surfl )
+      ELSE
+         iray = nrays
+         DO WHILE ( iray > 0  .AND.  zdirs(iray) <= full_horizon )
+            itarget(iray) = HUGE(1_iwp)
+            iray = iray - 1
          ENDDO
-
-         DEALLOCATE( target_surfl )
-
-      ELSE
-         itarget(:) = -1
+         itarget(1:iray) = -1
       ENDIF ! rad_angular_discretization
 
@@ -9041,5 +9138,6 @@
 !--               cause less moiree.
                   IF ( .NOT. rad_angular_discretization )  THEN
-                     IF ( zdirs(k) <= horizon )  CYCLE
+                     ! TODO: remove tradiational discretization (incompatible with full 3D)
+                     IF ( zdirs(k) <= full_horizon )  CYCLE
                   ENDIF
 
@@ -9052,5 +9150,5 @@
                      nz = 2
                      rt2_dist(nz) = SQRT(dxxyy)
-                     iz = CEILING(-.5_wp + zorig, iwp)
+                     kz = CEILING(-.5_wp + zorig, iwp)
                   ELSE
                      zexit = MIN(MAX(origin(1) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
@@ -9062,10 +9160,10 @@
                      qdist = rt2_dist(nz) / (zexit-zorig)
                      rt2_dist(2:nz-1) = (/( ((REAL(l, wp) + .5_wp) * zsgn - zorig) * qdist , l = zb0, zb1 )/)
-                     iz = zb0 * zsgn
+                     kz = zb0 * zsgn
                   ENDIF
 
                   DO  l = 2, nz
-                     IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
-                        curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
+                     IF ( rt2_track_lad(kz, i) > 0._wp )  THEN
+                        curtrans = exp(-ext_coef * rt2_track_lad(kz, i) * (rt2_dist(l)-rt2_dist(l-1)))
 
                         IF ( create_csf )  THEN
@@ -9074,5 +9172,5 @@
                            acsf(ncsfl)%itx = rt2_track(2,i)
                            acsf(ncsfl)%ity = rt2_track(1,i)
-                           acsf(ncsfl)%itz = iz
+                           acsf(ncsfl)%itz = kz
                            acsf(ncsfl)%isurfs = iorig
                            acsf(ncsfl)%rcvf = (1._wp - curtrans)*transparency(k)*vffrac(k)
@@ -9081,10 +9179,11 @@
                         transparency(k) = transparency(k) * curtrans
                      ENDIF
-                     iz = iz + zsgn
+                     kz = kz + zsgn
                   ENDDO ! l = 1, nz - 1
                ENDDO ! k = 1, nrays
             ENDDO ! i = 1, ntrack
-
-            transparency(1:lowest_free_ray) = 1._wp !-- Reset rays above horizon to transparent (see NOTE 6778)
+!
+!--         Reset rays above horizon to transparent (see NOTE 6778)
+            WHERE( itarget < 0 )  transparency = 1.0_wp
          ENDIF
 
@@ -9098,5 +9197,5 @@
 !
 !--            See NOTE 6778 above
-               IF ( zdirs(k) <= horizon )  CYCLE
+               IF ( itarget(k) >= 0 )  CYCLE
 
                zexit = origin(1) + zdirs(k) * rt2_track_dist(i-1)
@@ -9108,5 +9207,5 @@
                   nz = 2
                   rt2_dist(nz) = SQRT(dxxyy)
-                  iz = NINT(zexit, iwp)
+                  kz = NINT(zexit, iwp)
                ELSE
                   zorig = MIN(MAX(origin(1) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
@@ -9118,10 +9217,10 @@
                   qdist = rt2_dist(nz) / (zexit-zorig)
                   rt2_dist(2:nz-1) = (/( ((REAL(l, wp) + .5_wp) * zsgn - zorig) * qdist , l = zb0, zb1 )/)
-                  iz = zb0 * zsgn
+                  kz = zb0 * zsgn
                ENDIF
 
                DO  l = 2, nz
-                  IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
-                     curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
+                  IF ( rt2_track_lad(kz, i) > 0._wp )  THEN
+                     curtrans = exp(-ext_coef * rt2_track_lad(kz, i) * (rt2_dist(l)-rt2_dist(l-1)))
 
                      IF ( create_csf )  THEN
@@ -9130,6 +9229,5 @@
                         acsf(ncsfl)%itx = rt2_track(2,i)
                         acsf(ncsfl)%ity = rt2_track(1,i)
-                        acsf(ncsfl)%itz = iz
-                        IF ( itarget(k) /= -1 ) STOP 1 !FIXME remove after test
+                        acsf(ncsfl)%itz = kz
                         acsf(ncsfl)%isurfs = -1
                         acsf(ncsfl)%rcvf = (1._wp - curtrans)*transparency(k)*aorig*vffrac(k)
@@ -9138,5 +9236,5 @@
                      transparency(k) = transparency(k) * curtrans
                   ENDIF
-                  iz = iz + zsgn
+                  kz = kz + zsgn
                ENDDO ! l = 1, nz - 1
             ENDDO ! k = 1, nrays
@@ -9144,20 +9242,11 @@
       ENDIF ! plant_canopy
 
-      IF ( .NOT. (rad_angular_discretization  .AND.  calc_svf) )  THEN
-!
-!--      Just update lowest_free_ray according to horizon
-         DO WHILE ( lowest_free_ray > 0 )
-            IF ( zdirs(lowest_free_ray) > horizon )  EXIT
-            lowest_free_ray = lowest_free_ray - 1
-         ENDDO
-      ENDIF
-
    CONTAINS
 
-      SUBROUTINE request_itarget( d, z, y, x, isurfl, iproc )
+      SUBROUTINE request_itarget( d, z, y, x, isurfl )
 
          INTEGER(iwp), INTENT(in)            ::  d, z, y, x
          INTEGER(iwp), TARGET, INTENT(out)   ::  isurfl
-         INTEGER(iwp), INTENT(out)           ::  iproc
+         INTEGER(iwp)                        ::  iproc
 
 #if defined( __parallel )
@@ -9181,5 +9270,4 @@
 !--      set index target_surfl(i)
          isurfl = gridsurf(d,z,y,x)
-         iproc  = 0  ! required to avoid compile error about unused variable in serial mode
 #endif
 
@@ -9299,39 +9387,34 @@
 
 !-- first check: are the two surfaces directed in the same direction
-        IF ( (d==iup_u  .OR.  d==iup_l )                             &
-             .AND. (d2==iup_u  .OR. d2==iup_l) ) RETURN
-        IF ( (d==isouth_u  .OR.  d==isouth_l ) &
-             .AND.  (d2==isouth_u  .OR.  d2==isouth_l) ) RETURN
-        IF ( (d==inorth_u  .OR.  d==inorth_l ) &
-             .AND.  (d2==inorth_u  .OR.  d2==inorth_l) ) RETURN
-        IF ( (d==iwest_u  .OR.  d==iwest_l )     &
-             .AND.  (d2==iwest_u  .OR.  d2==iwest_l ) ) RETURN
-        IF ( (d==ieast_u  .OR.  d==ieast_l )     &
-             .AND.  (d2==ieast_u  .OR.  d2==ieast_l ) ) RETURN
+        IF ( d==iup     .AND.  d2==iup    ) RETURN
+        IF ( d==isouth  .AND.  d2==isouth ) RETURN
+        IF ( d==inorth  .AND.  d2==inorth ) RETURN
+        IF ( d==iwest   .AND.  d2==iwest  ) RETURN
+        IF ( d==ieast   .AND.  d2==ieast  ) RETURN
 
 !-- second check: are surfaces facing away from each other
         SELECT CASE (d)
-            CASE (iup_u, iup_l)                     !< upward facing surfaces
+            CASE (iup)                  !< upward facing surfaces
                 IF ( z2 < z ) RETURN
-            CASE (isouth_u, isouth_l)               !< southward facing surfaces
+            CASE (isouth)               !< southward facing surfaces
                 IF ( y2 > y ) RETURN
-            CASE (inorth_u, inorth_l)               !< northward facing surfaces
+            CASE (inorth)               !< northward facing surfaces
                 IF ( y2 < y ) RETURN
-            CASE (iwest_u, iwest_l)                 !< westward facing surfaces
+            CASE (iwest)                !< westward facing surfaces
                 IF ( x2 > x ) RETURN
-            CASE (ieast_u, ieast_l)                 !< eastward facing surfaces
+            CASE (ieast)                !< eastward facing surfaces
                 IF ( x2 < x ) RETURN
         END SELECT
 
         SELECT CASE (d2)
-            CASE (iup_u)                            !< ground, roof
+            CASE (iup)                  !< ground, roof
                 IF ( z < z2 ) RETURN
-            CASE (isouth_u, isouth_l)               !< south facing
+            CASE (isouth)               !< south facing
                 IF ( y > y2 ) RETURN
-            CASE (inorth_u, inorth_l)               !< north facing
+            CASE (inorth)               !< north facing
                 IF ( y < y2 ) RETURN
-            CASE (iwest_u, iwest_l)                 !< west facing
+            CASE (iwest)                !< west facing
                 IF ( x > x2 ) RETURN
-            CASE (ieast_u, ieast_l)                 !< east facing
+            CASE (ieast)                !< east facing
                 IF ( x < x2 ) RETURN
             CASE (-1)
@@ -9938,5 +10021,5 @@
     INTEGER(iwp) ::  l, m !< index of current surface element
     
-    INTEGER(iwp)                                       :: ids, idsint_u, idsint_l, isurf
+    INTEGER(iwp)                                       :: ids, idsint, isurf
     CHARACTER(LEN=varnamelength)                       :: var
 
@@ -9951,6 +10034,5 @@
            IF ( TRIM(var(k-j+1:k)) == TRIM(dirname(i)) )  THEN
                ids = i
-               idsint_u = dirint_u(ids)
-               idsint_l = dirint_l(ids)
+               idsint = dirint(ids)
                var = var(:k-j)
                EXIT
@@ -10399,6 +10481,6 @@
           CASE ( 'rtm_rad_net' )
 !--           array of complete radiation balance
-              DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                 IF ( surfl(id,isurf) == idsint )  THEN
                     surfradnet_av(isurf) = surfradnet_av(isurf) +               &
                                            surfinsw(isurf) - surfoutsw(isurf) + &
@@ -10409,6 +10491,6 @@
           CASE ( 'rtm_rad_insw' )
 !--           array of sw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinsw_av(isurf) = surfinsw_av(isurf) + surfinsw(isurf)
                   ENDIF
@@ -10417,6 +10499,6 @@
           CASE ( 'rtm_rad_inlw' )
 !--           array of lw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinlw_av(isurf) = surfinlw_av(isurf) + surfinlw(isurf)
                   ENDIF
@@ -10425,6 +10507,6 @@
           CASE ( 'rtm_rad_inswdir' )
 !--           array of direct sw radiation falling to surface from sun
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinswdir_av(isurf) = surfinswdir_av(isurf) + surfinswdir(isurf)
                   ENDIF
@@ -10433,6 +10515,6 @@
           CASE ( 'rtm_rad_inswdif' )
 !--           array of difusion sw radiation falling to surface from sky and borders of the domain
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinswdif_av(isurf) = surfinswdif_av(isurf) + surfinswdif(isurf)
                   ENDIF
@@ -10441,6 +10523,6 @@
           CASE ( 'rtm_rad_inswref' )
 !--           array of sw radiation falling to surface from reflections
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinswref_av(isurf) = surfinswref_av(isurf) + surfinsw(isurf) - &
                                           surfinswdir(isurf) - surfinswdif(isurf)
@@ -10451,6 +10533,6 @@
           CASE ( 'rtm_rad_inlwdif' )
 !--           array of sw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinlwdif_av(isurf) = surfinlwdif_av(isurf) + surfinlwdif(isurf)
                   ENDIF
@@ -10459,6 +10541,6 @@
           CASE ( 'rtm_rad_inlwref' )
 !--           array of lw radiation falling to surface from reflections
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinlwref_av(isurf) = surfinlwref_av(isurf) + &
                                           surfinlw(isurf) - surfinlwdif(isurf)
@@ -10468,6 +10550,6 @@
           CASE ( 'rtm_rad_outsw' )
 !--           array of sw radiation emitted from surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfoutsw_av(isurf) = surfoutsw_av(isurf) + surfoutsw(isurf)
                   ENDIF
@@ -10476,6 +10558,6 @@
           CASE ( 'rtm_rad_outlw' )
 !--           array of lw radiation emitted from surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfoutlw_av(isurf) = surfoutlw_av(isurf) + surfoutlw(isurf)
                   ENDIF
@@ -10484,6 +10566,6 @@
           CASE ( 'rtm_rad_ressw' )
 !--           array of residua of sw radiation absorbed in surface after last reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfins_av(isurf) = surfins_av(isurf) + surfins(isurf)
                   ENDIF
@@ -10492,6 +10574,6 @@
           CASE ( 'rtm_rad_reslw' )
 !--           array of residua of lw radiation absorbed in surface after last reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinl_av(isurf) = surfinl_av(isurf) + surfinl(isurf)
                   ENDIF
@@ -10696,6 +10778,6 @@
           CASE ( 'rtm_rad_net' )
 !--           array of complete radiation balance
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfradnet_av(isurf) = surfradnet_av(isurf) / REAL( average_count_3d, kind=wp )
                   ENDIF
@@ -10704,6 +10786,6 @@
           CASE ( 'rtm_rad_insw' )
 !--           array of sw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinsw_av(isurf) = surfinsw_av(isurf) / REAL( average_count_3d, kind=wp )
                   ENDIF
@@ -10712,6 +10794,6 @@
           CASE ( 'rtm_rad_inlw' )
 !--           array of lw radiation falling to surface after i-th reflection
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinlw_av(isurf) = surfinlw_av(isurf) / REAL( average_count_3d, kind=wp )
                   ENDIF
@@ -10720,6 +10802,6 @@
           CASE ( 'rtm_rad_inswdir' )
 !--           array of direct sw radiation falling to surface from sun
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinswdir_av(isurf) = surfinswdir_av(isurf) / REAL( average_count_3d, kind=wp )
                   ENDIF
@@ -10728,6 +10810,6 @@
           CASE ( 'rtm_rad_inswdif' )
 !--           array of difusion sw radiation falling to surface from sky and borders of the domain
-              DO isurf = dirstart(ids), dirend(ids)
-                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+              DO isurf = 1, nsurfl
+                  IF ( surfl(id,isurf) == idsint )  THEN
                       surfinswdif_av(isurf) = surfinswdif_av(isurf) / REAL( average_count_3d, kind=wp )
                   ENDIF
